{ In gioco2b.pas si e' implementata l'automobile come un
  dato astratto, ma si puo' notare che anche il mondo, ossia
  le variabili che definiscono l'ambiente nel quale l'auto si muove
  possono essere considerate un dato astratto: vediamo come.

  Il vantaggio e' che nuove variabili del dato astratto "mondo" possono
  essere aggiunte per rendere piu' realistico il comportamento del gioco,
  senza dover modificare le procedure gia' presenti per il mondo
  (lo si e' fatto per le auto che ora hanno un nome, ossia il nome
   del modello). 

  
  Si noti che guidare a 2000 km/h e' consentito nel mondo dei cartoni animati,
  ossia "cartoonia", ma non sulla terra.
}
program Gioco2c;
const 
   riga = 5.0; { a quanti metri dal bordo della corsia di marcia
                 si trova la riga di centro-strada. }

type
   Automobili = record
                   larghezzaMacchina, {Non e' piu' una costanta: possiamo
		                         avere macchine di diversa grandezza.}
	           posizione : real;
                   velocita : integer;
		   nome : string;    {novita'! Le macchine hanno un nome ora.}
                 end;
   Mondo = record
              riga : real;
              toccataRiga : boolean;
	      limiteVelocita : integer; {velocita max consentita}
              posizioneMinima : real;   {se la posizione di una
	                                 macchina e' minore di questa
					 significa che la vettura sta
					 cadendo nel fosso al bordo
					 della strata. }
           end;

var
   finePartita : boolean;
   auto: Automobili;
   terra,cartoonia : Mondo;
   scelta : integer;

{ -------------------------------------------------- }

procedure inizializzaAutomobili(var a:Automobili);
begin
   a.larghezzaMacchina := 2.5;
   a.velocita := 100;
   a.posizione := 2.0;
   a.nome := '127Sporting';
end;

{ Se cambia modello di Automobili, cambiera' potenzialmente anche
  la larghezza del veicolo. } 
procedure cambiaNomeLarghezza(var a:Automobili;nuovoNome : string;
                                               nuovaLarghezza : integer);
begin
   a.nome := nuovoNome;
   a.larghezzaMacchina := nuovaLarghezza;
end;

procedure modificaVelocita(var a:Automobili;dv : integer);
begin
   a.velocita := a.velocita + dv;
end;

procedure dimezzaVelocita(var a:Automobili);
begin
   a.velocita := a.velocita div 2;
end;

procedure modificaPosizione(var a:Automobili;dp : real);
begin
   a.posizione := a.posizione + dp;
end;

procedure stampaAutomobile(a : Automobili);
begin
   writeln('La macchina ',a.nome,' sta viaggiando a ',a.velocita,' Km/h');
   writeln('e dista ',a.posizione:2:2,' metri dal bordo della corsia');
end;

{ -------------------------------------------------- }

procedure inizializzaMondo(var m:Mondo;
                           riga : real;
			   limiteVelocita : integer;
			   posizioneMinima : real) ;
begin
   m.riga := riga;
   m.toccataRiga := false;
   m.limiteVelocita := limiteVelocita;
   m.posizioneMinima := posizioneMinima;
end;

procedure haiToccato(var m:Mondo);
begin
   m.toccataRiga := true;
end;

function toccato(m:Mondo):boolean;
begin
   toccato := m.toccataRiga;
end;

{ -------------------------------------------------- }

procedure controllaConsistenza(var a:Automobili;
                               var m:Mondo;
                               var fine : boolean );
begin
   if (a.posizione<=m.posizioneMinima) then
   begin
      write('Sei a meno di ',m.posizioneMinima:2:2,'cm dal fosso:');
      writeln('la macchina esce di strada.');
      fine:=true;
   end;
   if (a.velocita>=m.limiteVelocita) then
   begin
      writeln('La macchina va troppo veloce.');
      fine:=true;
   end;

   {pesto la riga di centro strada}
   if (a.posizione+a.larghezzaMacchina=m.riga) then 
      haiToccato(m);
end;

{ ------------------------------------------------------------- }

begin
   inizializzaAutomobili(auto);
   inizializzaMondo(terra, 5.0, 200, 0.1);

   { Non verra' usato in pratica, 
     ma descrive un diverso mondo }
   inizializzaMondo(cartoonia, 8.0, 2500, -0.5);

   finePartita := false;
   while not finePartita do
   begin
       stampaAutomobile(auto);
       writeln('E'' possibile:');
       writeln('0) uscire dal gioco');
       writeln('1) accelerare di 10 Km/h');
       writeln('2) dimezzare la velocita'' (divisione intera)');
       writeln('3) spostare la macchina 10 cm verso il bordo (a sinistra) ');
       writeln('4) spostare la macchina 10 cm verso l''altra corsia (a destra)');
       writeln;
       write('Digita la scelta: ');
       readln( scelta );

       if (scelta=0) then
          finePartita := true;
       if (scelta=1) then
          modificaVelocita(auto,+10);
       if (scelta=2) then
          dimezzaVelocita(auto);
       if (scelta=3) then
          modificaPosizione(auto,-0.1);
       if (scelta=4) then
          modificaPosizione(auto,+0.1);

       controllaConsistenza(auto,terra,finePartita);
   end;

   if ( toccato(terra) ) then
      writeln('Complimenti: hai quasi invaso la corsia opposta!');

   writeln;
   writeln('Game Over');
end.

